<script setup lang="ts">
import { ref, reactive, watch, nextTick } from "vue";
class Person {
  id: number;
  name: string;
  surname: string;
  gender: string;
  static lastId = 1;
  constructor(name: string, surname: string, gender: string) {
    this.id = Person.lastId++;
    this.name = name;
    this.surname = surname;
    this.gender = gender;
  }
}
const person = reactive<Person>({ id: -1, name: "", surname: "", gender: "" });
const msg = reactive({ name: "", surname: "", gender: "" });
const personlist = ref<Person[]>([]);
const showForm = ref(false);
const clearForm = function () {
  person.name = "";
  person.surname = "";
  person.gender = "";
  msg.name = "";
  msg.surname = "";
  msg.gender = "";
  person.id = -1;

  nextTick(() => {
    //update form  finished
    msg.name = "";
    msg.surname = "";
    msg.gender = "";
  });
};
function onSubmit() {
  if (
    checkName(person.name) &&
    checkSurname(person.surname) &&
    checkgender(person.gender)
  ) {
    if (person.id < 0) {
      const p = new Person(person.name, person.surname, person.gender);
      personlist.value.push(p);
      console.log(personlist.value);
    } else {
      const index = personlist.value.findIndex((item) => item.id === person.id);
      personlist.value[index].name = person.name;
      personlist.value[index].surname = person.surname;
      personlist.value[index].gender = person.gender;
    }

    clearForm();
    showForm.value = false;
  }
}
const onEdit = function (p: Person) {
  person.name = p.name;
  person.surname = p.surname;
  person.gender = p.gender;
  person.id = p.id;
  showForm.value = true;
};
const onDelete = function (p: Person) {
  const index = personlist.value.findIndex((item) => item.id === p.id);
  personlist.value.splice(index, 1);
};

const checkName = function (name: string) {
  if (name.trim().length == 0) {
    msg.name = "First name is required";
    return false;
  }
  msg.name = "";
  return true;
};
const checkSurname = function (surname: string) {
  if (surname.trim().length == 0) {
    msg.surname = "Surname is required";
    return false;
  }
  msg.surname = "";
  return true;
};
const checkgender = function (gender: string) {
  if (gender.trim().length == 0) {
    msg.gender = "Gender is required";
    return false;
  }
  msg.gender = "";
  return true;
};

watch(
  () => person.name,
  (name) => {
    checkName(name);
  }
);
watch(
  () => person.surname,
  (surname) => {
    checkSurname(surname);
  }
);
watch(
  () => person.gender,
  (gender) => {
    checkgender(gender);
  }
);
</script>

<template>
  <div class="PS">Person</div>
  <div v-if="showForm">
    <form>
      <label for="name">Name</label>
      <input
        type="text"
        id="name"
        name="firstname"
        placeholder="Name"
        v-model="person.name"
        autocomplete="off"
      />
      <span class="error">{{ msg.name }}</span>

      <label for="surname">Surname</label>
      <input
        type="text"
        id="surname"
        name="lastname"
        placeholder="Surname"
        v-model="person.surname"
        autocomplete="off"
      />
      <span class="error">{{ msg.surname }}</span>

      <label for="gender">Gender</label>
      <select id="gender" name="gender" v-model="person.gender">
        <option value="" selected hidden>Select Gender</option>
        <option value="M">Male</option>
        <option value="F">Female</option>
      </select>
      <span class="error">{{ msg.gender }}</span>

      <input type="submit" value="Submit" @click.prevent="onSubmit" />
    </form>
  </div>
  <div v-if="!showForm">
    <div style="width: 100%; text-align: right">
      <button @click="showForm = !showForm">Add</button>
    </div>

    <table id="persons">
      <thead>
        <th>ID</th>
        <th>First Name</th>
        <th>SurName</th>
        <th>Gender</th>
        <th style="width: 250px">Operation</th>
      </thead>
      <tr v-for="(item, index) in personlist" :key="index">
        <td>{{ item.id }}</td>
        <td>{{ item.name }}</td>
        <td>{{ item.surname }}</td>
        <td>{{ item.gender }}</td>
        <td class="center">
          <button
            style="width: 100px; background-color: gray"
            @click="onEdit(item)"
          >
            Edit
          </button>
          <button
            style="width: 100px; margin-left: 5px; background-color: red"
            @click="onDelete(item)"
          >
            Delete
          </button>
        </td>
      </tr>
      <tr>
        <td
          colspan="5"
          style="text-align: center"
          v-if="personlist.length == 0"
        >
          No data
        </td>
      </tr>
    </table>
  </div>
</template>

<style scoped>
input[type="text"],
select {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  display: inline-block;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
}

input[type="submit"] {
  width: 100%;
  background-color: #4caf50;
  color: white;
  padding: 14px 20px;
  margin: 8px 0;
  border: none;
  border-radius: 4px;
  cursor: pointer;
}
button {
  background-color: #4caf50;
  color: white;
  padding: 14px 20px;
  border: none;
  border-radius: 4px;
}

input[type="submit"]:hover {
  background-color: #45a049;
}

div {
  border-radius: 5px;
  background-color: #f2f2f2;
  padding: 20px;
}
label,
pre {
  color: rgb(0, 0, 0);
}
.PS {
  text-align: left;
  color: rgb(0, 0, 0);
}
.error {
  color: red;
  font-size: smaller;
  display: block;
}
#persons {
  font-family: Arial, Helvetica, sans-serif;
  border-collapse: collapse;
  width: 100%;
}

#persons td,
#persons th {
  border: 1px solid #ddd;
  padding: 8px;
  color: rgb(0, 0, 0);
}

#persons tr:nth-child(even) {
  background-color: #f2f2f2;
}

#persons tr:hover {
  background-color: #ddd;
}

#persons th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #04aa6d;
  color: white;
}
</style>
